<script setup>
import {Search} from "@element-plus/icons-vue";
import {reactive} from "vue";
import {useRouter} from "vue-router"
  import { useI18n } from 'vue-i18n'
  const { t } = useI18n()
  let language = ref(localStorage.getItem('lang') || 'zh')
const router = useRouter()
const add = ref(false)
const adda = ref(false)
import request from "@/utils/request"
import { ref, onMounted } from "vue";
// import { ref } from 'vue'
import { ElMessage, ElMessageBox } from 'element-plus'
//  import LanguageMixin from './lang/LanguageMixin'
const selectedProjectNoa = ref(null); // 当前选中的角色 
// const options = ref<any[]>([]); // 下拉选项列表  
  const name = ref('');
const tableData = ref([])
const options = ref([])
const selectedOptions = ref([])
// 定义级联选择器的属性  
const cascaderProps = {
  value: 'id',  
  label: 'menuName',  
  multiple: true
};  
const slot = ref('')

const titleSelectJsona = ref({
  processType: [],
 
})
onMounted(() => {  
  fetchOptionsa('');  
}); 
  // 角色下拉选  
  const fetchOptionsa = async () => {  
  try {  
    const response = await request.post('/loadGlass/sys/role/queryRole',{
  key: ''
});  
    if (response.code == 200) {  
     tableData.value = response.data
    // titleSelectJsona.value.processTypea = response.data.menuList;
    // options.value = response.data.menuList
    console.log(response.data);
 
    } else {  
      ElMessage.warning(response.data);  
    }  
  } catch (error) {  
    console.error('Error fetching options:', error);  
  }  
}; 
// 添加
const getTableRow = async () => {
  try {  
    let menuList = [];
     let parentIdMap = {}; // 用于存储已经添加的父项  
    selectedOptions.value.forEach(array => {  
      if (array.length >= 2) {  
        let id = array[0];  
        let parentId = array[1];  
        // 如果id还未作为父项添加，则添加它  
        if (!parentIdMap[id]) {  
          menuList.push({  
            id: id,  
            parentId: 0, // 通常，顶级项的parentId可能是null或特定的根ID，这里设为0可能是个特殊用途  
            children: []  
          });  
          parentIdMap[id] = menuList[menuList.length - 1]; // 更新映射  
        }  
        // 向对应的父项添加子项  
        if (!parentIdMap[id].children.some(child => child.id === parentId)) {  
          // 检查是否已存在相同的子项（基于id），避免重复添加  
          parentIdMap[id].children.push({  
            id: parentId,  
            parentId: id  
          });  
        }  
      }  
    });  
    const dataToSend = {  
      name: name.value,
      menuList: menuList
    };  
    const response = await request.post('/loadGlass/sys/role/saveRole', dataToSend);
    if (response.code == 200) {
      ElMessage.success(response.message);
      add.value = false;
      name.value = '';
      selectedOptions.value = '';
      fetchOptionsa();
    } else {
      ElMessage.error(response.message);
    }
  } catch (error) {
    console.error(error);
  }
};
function handleEdit(row) {  
  name.value = row.name;  
  adda.value = true;
  window.localStorage.setItem('ids', row.id);
  const parentIdMap = {};  
  const menuItemsById = {}; // 快速查找菜单项  
  let topLevelItems = []; // 存储顶级菜单项 
  row.menuList.forEach(item => {  
    const parentId = item.parentId === 0 ? null : item.parentId;
    const menuItem = {  
      id: item.id,  
      parentId: parentId,  
      menuName: item.menuName,  
      children: []  
    };  
    menuItemsById[item.id] = menuItem;  
    // 初始化或更新parentIdMap中的数组  
    if (!parentIdMap[parentId]) {  
      parentIdMap[parentId] = [];  
    }  
    if (parentId === null) {  
      // 顶级菜单项直接添加到topLevelItems  
      topLevelItems.push(menuItem);  
    } else {  
      // 非顶级菜单项添加到parentIdMap中  
      parentIdMap[parentId].push(menuItem);  
    }  
  });  
  for (const parentId in parentIdMap) {  
    if (parentId !== 'null') { // 跳过顶级菜单项  
      parentIdMap[parentId].forEach(child => {  
        // 查找父项并添加子项  
        if (menuItemsById[parentId]) {  
          menuItemsById[parentId].children.push(child);  
        }  
      });  
    }  
  }  
  if (selectedOptions.value !== topLevelItems) {  
    selectedOptions.value = topLevelItems;  
  }  
  console.log(topLevelItems);
  // selectedOptions.value = topLevelItems;
const topLevelItemsWithChildren = topLevelItems; // 包含顶级菜单项及其子菜单项的数组  
 let selectedPath = [];
// 循环遍历 topLevelItemsWithChildren 数组
for (let i = 0; i < topLevelItemsWithChildren.length; i++) {
 // 添加顶级菜单项的 id
 selectedPath.push(topLevelItemsWithChildren[i].id);
 // 如果有子菜单项，添加第一个子菜单项的 id
 if (topLevelItemsWithChildren[i].children && topLevelItemsWithChildren[i].children.length > 0) {
  for (let j = 0; j < topLevelItemsWithChildren[i].children.length; j++) {  
            // 将每个子菜单项的 id 添加到 selectedPath 中  
            selectedPath.push(topLevelItemsWithChildren[i].children[j].id);  
        }  
    }  
}
 console.log(selectedPath);
selectedOptions.value = selectedPath;
}
// 编辑
const getTableRowa = async () => {
  let ids = window.localStorage.getItem('ids')
  try {  
    let menuList = [];
     let parentIdMap = {}; // 用于存储已经添加的父项  
    selectedOptions.value.forEach(array => {  
      if (array.length >= 2) {  
        let id = array[0];  
        let parentId = array[1];  
        // 如果id还未作为父项添加，则添加它  
        if (!parentIdMap[id]) {  
          menuList.push({  
            id: id,  
            parentId: 0, // 通常，顶级项的parentId可能是null或特定的根ID，这里设为0可能是个特殊用途  
            children: []  
          });  
          parentIdMap[id] = menuList[menuList.length - 1]; // 更新映射  
        }  
        // 向对应的父项添加子项  
        if (!parentIdMap[id].children.some(child => child.id === parentId)) {  
          // 检查是否已存在相同的子项（基于id），避免重复添加  
          parentIdMap[id].children.push({  
            id: parentId,  
            parentId: id  
          });  
        }  
      }  
    });  
    const dataToSend = {  
      id:ids,
      name: name.value,
      menuList: menuList
    };  
    const response = await request.post('/loadGlass/sys/role/updateRole', dataToSend);
    if (response.code == 200) {
      ElMessage.success(response.message);
      adda.value = false;
      name.value = '';
      selectedOptions.value = '';
      fetchOptionsa();
    } else {
      ElMessage.error(response.message);
    }
  } catch (error) {
    console.error(error);
  }
};
function closeDialog(row) {
     add.value = false;
      name.value = '';
      selectedOptions.value = '';
}
function closeDialoga(row) {
     adda.value = false;
      name.value = '';
      selectedOptions.value = '';
}
// 删除 
 const opena = async(row) => {  
  try {
    const confirmResult = await ElMessageBox.confirm(  
      t('delivery.derole'), 
      t('delivery.prompt'),  
      {  
        confirmButtonText: t('delivery.yes'), 
        cancelButtonText: t('delivery.cancel'),
        type: 'warning',  
      } 
    ); 
    if (confirmResult === 'confirm') {  
      // 用户点击了“是”，现在调用删除接口  
      const response = await request.post("/loadGlass/sys/role/delete",[row.id])
    if (response.code === 200) {
      ElMessage.success(response.message);
      fetchOptionsa()
      } else {  
        // 删除失败，您可以处理错误或显示错误信息给用户  
      ElMessage.error(response.message);
        // alert('删除失败：' + deleteResponse.message); 
      }  
    }  
  } catch (error) {  
    // 处理可能出现的错误，比如 ElMessageBox 抛出的异常等  
    console.error('发生错误:', error);  
  }  
};
request.get("/loadGlass/sys/menu/nav").then((res) => {
 if (res.code == 200) {
 console.log(res.data);
 options.value = res.data.tree
 console.log( options.value);
 } else {
 ElMessage.warning(res.msg)
 }
 });
</script>

<template>
  <div>
     <el-button type="primary" style="margin-top: 10px;margin-left: 10px;"  size="mini" id="searchButton" @click="add = true">{{ $t('delivery.addrole') }}</el-button>
    <el-card style="flex: 1;margin-left: 10px;margin-top: 20px;" v-loading="loading">
      <div style="width: 98%; height: calc(100% - 35px); overflow-y: auto;">
        <el-table height="500" ref="table" 
        @selection-change="handleSelectionChange"
        :data="tableData" :header-cell-style="{background:'#F2F3F5 ',color:'#1D2129'}">
          <el-table-column prop="name" align="center" :label="$t('delivery.role')" min-width="180" />
          <el-table-column fixed="right" :label="$t('delivery.operate')" align="center" width="200">
            <template #default="scope">
              <el-button size="mini" type="text" plain  @click="handleEdit(scope.row)">{{ $t('delivery.edit') }}</el-button>
              <el-button size="mini" type="text" plain @click="opena(scope.row)">{{ $t('delivery.delete') }}</el-button>
            </template>
        </el-table-column>
        </el-table>
      </div>
    </el-card>
  </div>
  <el-dialog v-model="add" top="23vh" width="37%" :title="$t('productStock.addusername')" >
    <div style="margin-left: -50px;margin-top: 10px;margin-bottom: 10px;">
            <el-form ref="formRef" size="mini" label-width="150px">
      <el-form label-width="100px" label-position="right">
        <el-row style="margin-top: -15px;margin-bottom: -2px;">
          <el-col :span="6">
              <div id="dt" style="font-size: 15px;">
        <div>
          <el-form-item :label="$t('delivery.rolea')" :required="true" style="width: 25vw">
                <el-input :placeholder="$t('delivery.inrole')" v-model="name" autocomplete="off" />
              </el-form-item></div></div>
          </el-col>
        </el-row>
        <el-row style="margin-top: 10px;">
          <el-col :span="6">
              <div id="dt" style="font-size: 15px;">
        <div>
              <el-form-item :label="$t('delivery.choice')" :required="true" style="width: 25vw;">
        <el-cascader 
         v-model="selectedOptions" 
         :placeholder="$t('delivery.inchoice')"
         :props="cascaderProps"  
         :options="options" 
               style="width: 330px"
               clearable />
              </el-form-item></div></div>
          </el-col>
        </el-row>
        </el-form>
            </el-form>
          </div>
    <template #footer>
      <div id="dialog-footer">
        <el-button type="primary" @click="getTableRow">
          {{ $t('delivery.sure') }}
        </el-button>
        <el-button @click="closeDialog"> {{ $t('delivery.cancel') }}</el-button>
      </div>
    </template>
  </el-dialog> 
  <el-dialog v-model="adda" top="23vh" width="37%" :title="$t('delivery.editrole')">
    <div style="margin-left: -50px;margin-top: 10px;margin-bottom: 10px;">
            <el-form ref="formRef" size="mini" label-width="150px">
              <el-form label-width="100px" label-position="right">
        <el-row style="margin-top: -15px;margin-bottom: -2px;">
          <el-col :span="6">
              <div id="dt" style="font-size: 15px;">
        <div>
          <el-form-item :label="$t('delivery.rolea')" :required="true" style="width: 25vw">
                <el-input :placeholder="$t('delivery.inrole')" v-model="name" autocomplete="off" />
              </el-form-item></div></div>
          </el-col>
        </el-row>
        <el-row style="margin-top: 10px;">
          <el-col :span="6">
              <div id="dt" style="font-size: 15px;">
        <div>
       <el-form-item :label="$t('delivery.choice')" :required="true" style="width: 25vw;">
        <el-cascader 
         v-model="selectedOptions"  
         :placeholder="$t('delivery.inchoice')"
         :props="cascaderProps"  
         :options="options" 
               style="width: 330px"
               clearable />
              </el-form-item></div></div>
          </el-col>
        </el-row>
        </el-form>
            </el-form>
          </div>
    <template #footer>
      <div id="dialog-footer">
        <el-button type="primary" @click="getTableRowa">
          {{ $t('delivery.sure') }}
        </el-button>
        <el-button @click="closeDialoga">{{ $t('delivery.cancel') }}</el-button>
      </div>
    </template>
  </el-dialog> 
</template>

<style scoped>

#dt { display:block; float:left;line-height: 20px;margin-left: 100px;}
#dta { display:block; float:left;line-height: 20px;margin-left: 80%;}
#dialog-footer{
  text-align: center;
  margin-top: -15px;
}
#message{
  text-align: center;
  align-items: center;
  color: black;
   width: 200px;
   height: 100px;
   background-color: #337ecc;
   margin-left: 28%;
}
#awatch{
  height: 460px;
  /* margin-top: -60px; */
}
</style>